<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);
function createNeonWord($text, $fontPath, $fontSize, $shadowColors, $textColor, $padding , $border,$singleline , $backgroundcolor) {
    // انتخاب یک رنگ تصادفی از آرایه سایه‌ها
    $shadowColor = $shadowColors[array_rand($shadowColors)];

    // اندازه‌گیری متن برای سایز بوم
    $tempImage = new Imagick();
    $drawMetrics = new ImagickDraw();
    $drawMetrics->setFont($fontPath);
    $drawMetrics->setFontSize($fontSize);
    $textMetrics = $tempImage->queryFontMetrics($drawMetrics, $text );

    $width = ceil($textMetrics['textWidth']) + $padding * 2;
    $height = ceil($textMetrics['textHeight']) + $padding * 2 +50;

    // بوم پس‌زمینه شفاف
    $background = new Imagick();
    $background->newImage($width, $height, new ImagickPixel('transparent'));
    $background->setImageFormat("png");




if($border){
   
    // تنظیمات رسم سایه نئونی
    $bordero = new ImagickDraw();
    $bordero->setFont($fontPath);
    $bordero->setFontSize($fontSize);
    $bordero->setTextAlignment(Imagick::ALIGN_CENTER);
    $bordero->setFillColor('none');
    $bordero->setStrokeColor($backgroundcolor);
    $bordero->setStrokeWidth(50);
    
    
    $borderImage = new Imagick();
    $borderImage->newImage($width, $height, new ImagickPixel('transparent'));
    $borderImage->setImageFormat("png");
    $borderImage->annotateImage($bordero, $width / 2, $height / 2 + $textMetrics['textHeight'] / 4, 0, $text);
    $background->compositeImage($borderImage, Imagick::COMPOSITE_OVER, 0, 0);




}
    // تنظیمات رسم سایه نئونی
    $drawShadow = new ImagickDraw();
    $drawShadow->setFont($fontPath);
    $drawShadow->setFontSize($fontSize);
    $drawShadow->setTextAlignment(Imagick::ALIGN_CENTER);
    $drawShadow->setFillColor($shadowColor);
    $drawShadow->setStrokeColor($shadowColor);
    $drawShadow->setStrokeWidth(20);

    // ایجاد تصویر سایه
    $shadowImage = new Imagick();
    $shadowImage->newImage($width, $height, new ImagickPixel('transparent'));
    $shadowImage->setImageFormat("png");

    // رسم متن سایه
    $shadowImage->annotateImage($drawShadow, $width / 2, $height / 2 + $textMetrics['textHeight'] / 4, 0, $text);

    // بلور کردن سایه
    $shadowImage->blurImage(10, 5);

    // ترکیب سایه با بوم پس‌زمینه
    $background->compositeImage($shadowImage, Imagick::COMPOSITE_OVER, 0, 0);

    // تنظیمات رسم متن اصلی
    $drawText = new ImagickDraw();
    $drawText->setFont($fontPath);
    $drawText->setFontSize($fontSize);
    $drawText->setTextAlignment(Imagick::ALIGN_CENTER);
    
    if($singleline){ $drawText->setFillColor($textColor);
    $drawText->setStrokeColor('none');
        
    }
    else{
     
         $drawText->setFillColor('none');
    $drawText->setStrokeColor($textColor);
    }
   

    // رسم متن اصلی روی سایه
    $background->annotateImage($drawText, $width / 2, $height / 2 + $textMetrics['textHeight'] / 4, 0, $text);

    return $background;
}

function generateCombinedNeonText($text, $outputPath, $fontPath, $fontSize, $shadowColors, $textColor, $padding, $outputWidth , $border , $singleline, $backgroundcolor ) {
    $words = explode(' ', $text); // تقسیم متن به کلمات
    $layers = []; // ذخیره لایه‌های کلمات

    $totalWidth = 0; // عرض کل برای ترکیب تصاویر
    $maxHeight = 0; // بیشترین ارتفاع تصاویر

    foreach ($words as $word) {
        if (trim($word) === '') {
            continue; // حذف کلمات خالی
        }

        // ایجاد لایه نئونی برای هر کلمه
        $layer = createNeonWord($word, $fontPath, $fontSize, $shadowColors, $textColor, $padding,$border,$singleline , $backgroundcolor);

        // به‌روز رسانی مقادیر کل
        $totalWidth += $layer->getImageWidth();
        $maxHeight = max($maxHeight, $layer->getImageHeight());

        // ذخیره لایه
        $layers[] = $layer;
    }

    if (empty($layers)) {
        throw new Exception("هیچ کلمه‌ای برای پردازش موجود نیست.");
    }

    // ایجاد بوم نهایی برای ترکیب تصاویر
    $combined = new Imagick();
    $combined->newImage($totalWidth, $maxHeight, new ImagickPixel('transparent'));
    $combined->setImageFormat('png');

    // ترکیب تصاویر
    $xOffset = count($layers)*$padding/2;
    
    
    
    
    if (preg_match('/^[A-Za-z0-9\s\.,!?;:\'"-]*$/', $text)) {
    $layers=$layers;
} else {
    $layers=array_reverse($layers);
}
    //langauage
    
    foreach ($layers as $layer) {
        $combined->compositeImage($layer, Imagick::COMPOSITE_OVER, $xOffset, 0);
        $xOffset += $layer->getImageWidth()-$padding;
        $layer->destroy();
    }

    // تغییر اندازه به عرض خروجی مشخص‌شده
    $combined->resizeImage($outputWidth, 0, Imagick::FILTER_LANCZOS, 1);

    // ذخیره تصویر نهایی
    $combined->writeImage($outputPath);
    $combined->clear();
    $combined->destroy();
}

