<?php
// دریافت داده‌ها از وبهوک
$input = file_get_contents('php://input');
$update = json_decode($input, true);



// بررسی اینکه آیا پیام دریافتی وجود دارد
if (isset($update["message"])) {
    $message = $update["message"];

    // دریافت متن پیام
    if (isset($message["text"])) {
        $text = $message["text"];
        $chatId = $message["chat"]["id"];

        // پردازش متن و ایجاد تصویر
        $decodedText = decodeText($text);
        $imagePath = createImageWithText($decodedText);

        // ارسال تصویر به عنوان استیکر به تلگرام
        sendStickerToTelegram('-1002275505736', $imagePath);

        // حذف فایل تصویر پس از ارسال
        unlink($imagePath);
    }
}

// تابع decodeText برای ویرایش متن

function decodeText($text)
{$persianNumbers = array('۰', '۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹');
$englishNumbers = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9');

$text = strtr($text, array_combine($persianNumbers, $englishNumbers));
    if (preg_match('/فردا/u', $text)) {
    $text = preg_replace('/فردا/u', '', $text);
  
}    
    if (preg_match('/(?<!\pL)((خ|ف|مع|فف|خف|معن)|شنبه|یکشنبه|دوشنبه|سه شنبه|چهارشنبه|پنجشنبه|جمعه)(?!\pL)/u', $text)) {
        $text="حواله  فردا ".$text;
    $text = preg_replace('/(?<!\pL)خ(?!\pL)/u', ' خریدار 🔵 ', $text);
    $text = preg_replace('/(?<!\pL)ف(?!\pL)/u', '  فروشنده 🔴 ', $text);
    $text = preg_replace('/(?<!\pL)مع(?!\pL)/u','معامله ✅', $text);

if (preg_match('/شنبه/u', $text)) {
         $text = preg_replace('/شنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'شنبه', $text);
} 
elseif (preg_match('/یکشنبه/u', $text)) {
    $text = preg_replace('/یکشنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'یکشنبه', $text);
} 
elseif (preg_match('/دوشنبه/u', $text)) {
    $text = preg_replace('/دوشنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'دوشنبه', $text);
} 
elseif (preg_match('/سه شنبه/u', $text)) {
    $text = preg_replace('/سه شنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'سه شنبه', $text);
} 
elseif (preg_match('/چهارشنبه/u', $text)) {
    $text = preg_replace('/چهارشنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'چهارشنبه', $text);
} 
elseif (preg_match('/پنجشنبه/u', $text)) {
    $text = preg_replace('/پنجشنبه/u', '', $text);
    $text = preg_replace('/فردا/u', 'پنجشنبه', $text);
} 
elseif (preg_match('/جمعه/u', $text)) {
    $text = preg_replace('/جمعه/u', '', $text);
    $text = preg_replace('/فردا/u', 'جمعه', $text);
}

    if (preg_match('/فف/u', $text)) {
         $text = preg_replace('/فف/u', '  فروشنده 🔴 ', $text);
} 
elseif (preg_match('/خف/u', $text)) {
             $text = preg_replace('/خف/u', 'خریدار 🔵', $text);

} 
elseif (preg_match('/معن/u', $text)) {
             $text = preg_replace('/معن/u', 'معامله ✅', $text);
      $text = preg_replace('/حواله  فردا/u', 'نقد', $tex);
} 
elseif (preg_match('/خن/u', $text)) {
             $text = preg_replace('/خن/u', 'خریدار 🔵', $text);         
      $text = preg_replace('/حواله  فردا/u', 'نقد', $text);
} 

elseif (preg_match('/فن/u', $text)) {
    $text = preg_replace('/نقدی/u', '', $text);
             $text = preg_replace('/فن/u', 'فروشنده 🔴', $text);
    $text = preg_replace('/حواله  فردا/u', 'نقد حاضر', $text);  
} 
if (preg_match('/نقد/u', $text)) { $text = preg_replace('/نقدی/u','', $text);
    $text = preg_replace('/نقد/u','', $text);
             $text = preg_replace('/حواله/u','نقدی', $text);
       
} 
if (preg_match('/حاضر/u', $text)) {
    $text = preg_replace('/حاضر/u', '', $text);
             $text = preg_replace('/فردا/u', 'حاضر', $text);
} 

if (preg_match('/روز/u', $text)) {
    $text = preg_replace('/روز/u', '', $text);
             $text = preg_replace('/فردا/u', 'روز', $text);
} 


$text = strtr($text, array_combine($englishNumbers,$persianNumbers));
}

    return $text;
}

// تابع برای ایجاد تصویر با متن
function createImageWithText($text)
{
    $text = rtrim($text); // حذف فاصله‌های اضافی در انتهای متن

    // تنظیم مقیاس بالا برای بهبود کیفیت
    $scaleFactor = 4;
    $width = 512 * $scaleFactor;
    $height = 200 * $scaleFactor;

    // ایجاد تصویر با پس‌زمینه شفاف
    $image = new Imagick();
    $image->newImage($width, $height, new ImagickPixel('transparent'));
    $image->setImageFormat('webp'); // تنظیم فرمت خروجی به webp

    // تنظیمات دایره با توجه به اموجی
    $circle = new ImagickDraw();
    if (strpos($text, '🔵') !== false) {
        $text = preg_replace('/🔵/u', '', $text);
        $circle->setFillColor('blue');
    } elseif (strpos($text, '🔴') !== false) {
		$text = preg_replace('/🔴/u', '', $text);
        $circle->setFillColor('red');
    } elseif (strpos($text, '✅') !== false) {
		$text = preg_replace('/✅/u', '', $text);
        $circle->setFillColor('green');
    } else {
        $circle->setFillColor('red'); // رنگ پیش‌فرض
    }
    $circleRadius = 15 * $scaleFactor;
    $circleX = 60;
    $circleY = ($height + 100) / 3;
    $circle->circle($circleX, $circleY, $circleX + $circleRadius, $circleY);

    // اضافه کردن دایره به تصویر
    $image->drawImage($circle);

    // تنظیمات متن
    $draw = new ImagickDraw();
    $draw->setFont(__DIR__ . '/B-NAZANIN.TTF'); // استفاده از فونت سفارشی
    $draw->setFontSize(45 * $scaleFactor); // مقیاس دادن فونت
    $draw->setTextKerning(-5); // کاهش فاصله بین حروف

    // اندازه‌گیری عرض متن برای تنظیم افقی کنار دایره
    $metrics = $image->queryFontMetrics($draw, $text);
    $textX = $circleX + ($circleRadius);
    $textY = ($height + 60) / 2.5;

    // ایجاد استروک بیرونی سفید برای متن
    $draw->setFillColor('white');  // رنگ استروک سفید
    $draw->setStrokeColor('white');
    $draw->setStrokeWidth(10 * $scaleFactor);  // عرض استروک بزرگتر
    $draw->annotation($textX, $textY, $text);  // رسم استروک

    // رسم متن مشکی روی استروک
    $draw->setFillColor('black');  // رنگ متن مشکی
    $draw->setStrokeWidth(0);  // حذف استروک برای متن
    $draw->annotation($textX, $textY, $text);  // رسم متن اصلی

    // اضافه کردن متن به تصویر
    $image->drawImage($draw);

    // کوچک کردن تصویر به اندازه نهایی برای بهبود کیفیت
    $image->resizeImage(512, 200, Imagick::FILTER_LANCZOS, 1);

    // ذخیره تصویر به صورت فایل WebP در دایرکتوری جاری
    $outputPath = __DIR__ . '/output_image_' . time() . '.webp';
    $image->writeImage($outputPath);

    // حذف شیء‌ها برای آزاد کردن حافظه
    $image->clear();
    $image->destroy();
    $circle->clear();
    $circle->destroy();
    $draw->clear();
    $draw->destroy();

    echo "Image saved to: $outputPath";
    return $outputPath;
}

// تابع برای ارسال استیکر به تلگرام
function sendStickerToTelegram($chatId, $imagePath)
{
    $botToken = '8159970388:AAGjaaR2TRw072AQlMlPErdoqidSLy8zlh0';
    $url = "https://api.telegram.org/bot$botToken/sendSticker";

    $post_fields = [
        'chat_id' => $chatId,
        'sticker' => new CURLFile(realpath($imagePath))
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_HTTPHEADER, ["Content-Type:multipart/form-data"]);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields);
    $output = curl_exec($ch);
    curl_close($ch);

    echo "Sticker sent to Telegram: $output";
}
?>